// This program is designed for OKI-E5003 board
// It shows how to work with buttons, leds, optrons

#include <ioml67q5003.h>
#include "led.h"
#include "system.h"
#include "relay.h"
#include "optron.h"

#define   ON    1
#define   OFF   0

// simple delay
void Delay (unsigned long a) { while (--a!=0); }

bool b1_press = true;
bool b2_press = true;
bool b3_press = true;
bool b4_press = true;

unsigned char optron1 = OFF;
unsigned char optron2 = OFF;

int main()
{

  // Freq init
  FreqInit();
  // Init Led
  InitLED();
  // Init Relay
  InitRelay();
  // Init Optrons
  InitOpt();

  // loop forever
  while(1) {




    //press button 1
    if((GPPIA_bit.GPPIA2 == 0)&&(b1_press)) {
      LedHOn();
      b1_press = false;
    }
    if((GPPIA_bit.GPPIA2 == 1)&&(!b1_press)) {
      LedHOff();
      b1_press = true;
    }

    //press button 2
    if((GPPIA_bit.GPPIA3 == 0)&&(b2_press)) {
      LedBOn();
      b2_press = false;
    }
    if((GPPIA_bit.GPPIA3 == 1)&&(!b2_press)) {
      LedBOff();
      b2_press = true;
    }

    //press button 3
    if((GPPIA_bit.GPPIA4 == 0) && (b3_press) )
    {
      Relay1(1);
      b3_press = false;
    }
    if((GPPIA_bit.GPPIA4 == 1) && (!b3_press) )
    {
      Relay1(0);
      b3_press = true;
    }
    //press button 4
    if((GPPIA_bit.GPPIA7 == 0) && (b4_press))
    {
      Relay2(1);
      b4_press = false;
    }
    if((GPPIA_bit.GPPIA7 == 1) && (!b4_press))
    {
      Relay2(0);
      b4_press = true;
    }

   //// optrons ////
   //I1 -> Relay1 on/off
   if(GPPIE_bit.GPPIE6 == 0 && optron1==OFF) {
     Relay1(1);
     optron1 = ON;
   }
   if(GPPIE_bit.GPPIE6 != 0 && optron1==ON) {
     Relay1(0);
     optron1 = OFF;
   }

   //I2 -> Relay2 on/off
   if(GPPIE_bit.GPPIE8 == 0 && optron2==OFF) {
     Relay1(1);
     optron2 = ON;
   }
   if(GPPIE_bit.GPPIE8 != 0 && optron2==ON) {
     Relay1(0);
     optron2 = OFF;
   }

  }
}
